# Create Leads

> Source: https://truto.one/docs/api-reference/unified-crm-api/leads/create/

`POST /unified/crm/leads`

Resource: **Leads** · API: **Unified CRM API**

## Supported integrations

Microsoft Dynamics 365 Sales, HubSpot, Insightly, Monday CRM, Nutshell, Pipedrive, Pipeliner, Salesforce, Zendesk Sell, Zoho CRM

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.

## Request body

- **`first_name`** _(string)_
  The lead's first name
- **`last_name`** _(string)_
  The lead's last name
- **`owner`** _(object)_
  The lead's owner
  - **`id`** _(string)_
    The lead's owner's unique identifier
- **`lead_source`** _(string)_
  The lead's source
  Allowed: `Advertisement`, `Employee Referral`, `External Referral`, `Partner`, `Public Relations`, `Seminar`, `Trade Show`, `Web`, `Word of Mouth`, `Other`
- **`title`** _(string)_
  The lead's title
- **`account`** _(object)_
  The lead's account
  - **`id`** _(string)_
    The account's unique identifier
- **`contact`** _(object)_
  The contact associated with the lead
  - **`id`** _(string)_
    The contact's unique identifier
- **`addresses`** _(array<object>)_
  - **`street_1`** _(string)_
    Line 1 of the street address
  - **`street_2`** _(string)_
    Line 2 of the street address
  - **`city`** _(string)_
    The city
  - **`state`** _(string)_
    The state
  - **`postal_code`** _(string)_
    The postal code
  - **`country`** _(string)_
    The country
  - **`type`** _(string)_
    The address type
- **`email_addresses`** _(array<object>)_
  - **`email`** _(string, required)_
    The email address
  - **`type`** _(string, required)_
    The email address type
    Allowed: `primary`, `secondary`, `primary`, `secondary`
- **`phone_numbers`** _(array<object>)_
  - **`number`** _(string, required)_
    The phone number
  - **`extension`** _(string)_
    The extension of the phone number
  - **`type`** _(string, required)_
    The phone number type
    Allowed: `work`, `mobile`, `fax`, `phone`, `fax`, `phone`, `fax`
  - **`email`** _(string)_
  - **`is_primary`** _(string)_
- **`lead_type`** _(string)_
  The lead's type
- **`status`** _(string)_
  The lead's status
  Allowed: `attempted to contact`, `new lead`, `contacted`, `unqualified`, `qualified`, `new`, `working`, `unqualified`
- **`custom_fields`** _(object)_
  All the custom fields present on the lead
- **`name`** _(unknown)_
- **`description`** _(unknown)_
- **`created_at`** _(string)_
  The date and time of the lead's creation
- **`converted_contact`** _(object)_
  The lead's converted contact
  - **`id`** _(string)_
    The converted contact's unique identifier
- **`converted_account`** _(object)_
  The lead's converted account
  - **`id`** _(string)_
    The converted account's unique identifier
- **`industry`** _(unknown)_
- **`website`** _(unknown)_
- **`number_of_employees`** _(unknown)_
- **`remote_data`** _(object)_
  Any additional data that should be passed as part of the request body. This data is not transformed by Truto and is passed as is to the remote API.

## Response body

- **`id`** _(string, required)_
  The lead' unique identifier
- **`owner`** _(object)_
  The lead's owner
  - **`id`** _(string)_
    The lead's owner's unique identifier
- **`lead_source`** _(string)_
  The lead's source
- **`lead_type`** _(string)_
  The lead's type
- **`status`** _(string)_
  The lead's status
- **`title`** _(string)_
  The lead's title
- **`contact`** _(object)_
  The contact associated with the lead
  - **`id`** _(string)_
    The contact's unique identifier
- **`account`** _(object)_
  The lead's account
  - **`id`** _(string)_
    The account's unique identifier
- **`first_name`** _(string)_
  The lead's first name
- **`last_name`** _(string)_
  The lead's last name
- **`addresses`** _(array<object>)_
  - **`street_1`** _(string)_
    Line 1 of the street address
  - **`street_2`** _(string)_
    Line 2 of the street address
  - **`city`** _(string)_
    The city
  - **`state`** _(string)_
    The state
  - **`postal_code`** _(string)_
    The postal code
  - **`country`** _(string)_
    The country
  - **`type`** _(string)_
    The address type
- **`email_addresses`** _(array<object>)_
  - **`email`** _(string)_
    The email address
  - **`type`** _(string)_
    The email address type
- **`phone_numbers`** _(array<object>)_
  - **`number`** _(string)_
    The phone number
  - **`extension`** _(string)_
    The extension of the phone number
  - **`type`** _(string)_
    The phone number type
- **`custom_fields`** _(object)_
  All the custom fields present on the lead
- **`last_activity_at`** _(string)_
  The date and time of the lead's last activity
- **`created_at`** _(string)_
  The date and time of the lead's creation
- **`updated_at`** _(string)_
  The date and time of the lead's last update
- **`converted_at`** _(string)_
  The date and time of the lead's conversion
- **`converted_contact`** _(string)_
  The lead's converted contact
- **`converted_account`** _(string)_
  The lead's converted account
- **`urls`** _(array<object>)_
  The lead's urls
  - **`url`** _(string)_
    The lead's URL
  - **`type`** _(string)_
    The lead's URL type
- **`remote_data`** _(object)_
  Raw data returned from the remote API call.

## Code examples

### curl

```bash
curl -X POST 'https://api.truto.one/unified/crm/leads?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json' \
  -d '{
  "first_name": "your_first_name",
  "last_name": "your_last_name",
  "owner": {},
  "lead_source": "Advertisement",
  "title": "your_title",
  "account": {},
  "contact": {},
  "addresses": [],
  "email_addresses": [],
  "phone_numbers": [],
  "lead_type": "your_lead_type",
  "status": "attempted to contact",
  "custom_fields": {},
  "created_at": "your_created_at",
  "converted_contact": {},
  "converted_account": {},
  "remote_data": {}
}'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const body = {
  "first_name": "your_first_name",
  "last_name": "your_last_name",
  "owner": {},
  "lead_source": "Advertisement",
  "title": "your_title",
  "account": {},
  "contact": {},
  "addresses": [],
  "email_addresses": [],
  "phone_numbers": [],
  "lead_type": "your_lead_type",
  "status": "attempted to contact",
  "custom_fields": {},
  "created_at": "your_created_at",
  "converted_contact": {},
  "converted_account": {},
  "remote_data": {}
};

const response = await fetch(`https://api.truto.one/unified/crm/leads?integrated_account_id=${integratedAccountId}`, {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
  body: JSON.stringify(body),
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/crm/leads"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}
payload = {
    "first_name": "your_first_name",
    "last_name": "your_last_name",
    "owner": {},
    "lead_source": "Advertisement",
    "title": "your_title",
    "account": {},
    "contact": {},
    "addresses": [],
    "email_addresses": [],
    "phone_numbers": [],
    "lead_type": "your_lead_type",
    "status": "attempted to contact",
    "custom_fields": {},
    "created_at": "your_created_at",
    "converted_contact": {},
    "converted_account": {},
    "remote_data": {}
}

response = requests.post(url, headers=headers, params=params, json=payload)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.create(
  'crm',
  'leads',
  {
  "first_name": "your_first_name",
  "last_name": "your_last_name",
  "owner": {},
  "lead_source": "Advertisement",
  "title": "your_title",
  "account": {},
  "contact": {},
  "addresses": [],
  "email_addresses": [],
  "phone_numbers": [],
  "lead_type": "your_lead_type",
  "status": "attempted to contact",
  "custom_fields": {},
  "created_at": "your_created_at",
  "converted_contact": {},
  "converted_account": {},
  "remote_data": {}
},
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    result = await truto_api.unified_api.create(
        "crm",
        "leads",
        {
        "first_name": "your_first_name",
        "last_name": "your_last_name",
        "owner": {},
        "lead_source": "Advertisement",
        "title": "your_title",
        "account": {},
        "contact": {},
        "addresses": [],
        "email_addresses": [],
        "phone_numbers": [],
        "lead_type": "your_lead_type",
        "status": "attempted to contact",
        "custom_fields": {},
        "created_at": "your_created_at",
        "converted_contact": {},
        "converted_account": {},
        "remote_data": {}
},
        {"integrated_account_id": "<integrated_account_id>"}
    )
    print(result)

asyncio.run(main())
```
